<?php
if (!defined('PmWiki')) exit();
	
/*  This script is based "scripts/mailpost.php"
 * 
    Several variables control the functioning of this script:
 
    $SendPostsTo - comma separated list of Send recipients
	   ex: 
			$SendPostsTo="jondoe@jabbe.org:jabber;
					      pippo@pluto.it:email;
					      gino@hotmail.it:msn;"
					      
    $SendPostsToFile - if yoy want load list from a file, data stored
       must be in this form:
       ::jabber:jondoe@jabbe.org:
       ::email:pippo@pluto.it:
       ::msn:gino@hotmail.it:
    
    $SendPostsFrom - return eSend address
    $SendPostsDelay - number of seconds to wait before sending Send after
      the first post.  Useful so that lots of small edits result are 
      batched together in a single eSend message.  However, Send
      won't be sent until the first execution of pmwiki.php after the
      delay has expired, which could be much longer than the delay period
      itself depending on how active your site is.
    $SendPostsSquelch - minimum number of seconds between sending Send
      messages.  Useful when $SendPostsDelay is set to a small value
      to prevent large numbers of Send notifications to be sent.
    $SendPostsFile - scratch file used to keep track of recent posts
    $SendPostsMessage - body of message to be sent.  The sequence 
      '$SendPostsList' is replaced with the list of changes.
    $SendPostTimeFmt - the format for dates and times in $PostTime
    $SendPostItemFmt - the text to be sent for each changed item in the post.
      The string $PostTime contains the time of the post formatted
      according to $SendPostTimeFmt.
    $SendPostsSubject - subject line for Send to be sent
    $SendPostsHeaders - string of extra headers for Send (passed to PHP
       Send() function, some headers may not work for PHP < 4.3).
    $SendPostsFunction - If the default PHP Send function isn't working
       for you, then you can define your own Send function here or you
       can try "SendPostsSendSend".  
*/

### Configuration Variables #############################################

SDV($SendPostsTo,"");
SDV($SendPostsToFile,"/local/.htpasswd");
SDV($SendPostsDelay,0);
SDV($SendPostsSquelch,7200); # default 7200
SDV($SendPostsFile,getcwd()."/local/.sendposts");
SDV($SendPostsMessage,"\nRecent $WikiTitle posts:\n"
  ."  ($ScriptUrl?n=Site.AllRecentChanges)\n\n\$SendPostsList\n");
SDV($SendPostsSubject,"$WikiTitle recent wiki posts");
SDV($SendPostsTimeFmt,$TimeFmt);
SDV($SendPostsItemFmt,' * $FullName . . . $PostTime by $Author');
SDV($SendPostsHeaders,'');

### JabberPost Configuration Variables 
SDV($JabberPostUsername,'user');
SDV($JabberPostPassword,'password');
SDV($JabberPostServer,'jabber.com');
SDV($JabberPostPort,'5222');
SDV($JabberPostResource,'wiki');
##########################################################################

if (@ $SendPostsFrom)
	$SendPostsHeaders = "From: $SendPostsFrom\r\n$SendPostsHeaders";

array_push($EditFunctions, 'UpdatePosts');

if (@ $SendPostsTo == "")
	$SendPostsTo = LoadSendPostsTo(getcwd().$SendPostsToFile);
if (@ $SendPostsTo == "")
	return;

// legge il file dei post
$fp = @ fopen($SendPostsFile, "r");
if (!$fp)
	return;
$oldestpost = $Now +1;
$Sendpost = array ();
while (!feof($fp)) {
	@ (list ($t, $p) = explode(' ', rtrim(fgets($fp, 1024)), 2));
	if (!$t)
		continue;
	if ($p == '#lastSended') {
		if ($t > $Now - $SendPostsSquelch) {
			fclose($fp);
			return;
		}
		continue;
	}
	Lock(2);
	array_push($Sendpost, str_replace($Newline, "\n", $p)."\n");
	if ($t < $oldestpost)
		$oldestpost = $t;
}
fclose($fp);

if ($oldestpost > $Now - $SendPostsDelay) {
	Lock(0);
	return;
}

SendPosts($SendPostsTo, $SendPostsSubject, str_replace('$SendPostsList', join('', $Sendpost), $SendPostsMessage), $SendPostsHeaders);

$fp = @ fopen($SendPostsFile, "w");
if ($fp) {
	fputs($fp, "$Now #lastSended\n");
	fclose($fp);
}
Lock(0);

## functions ##

function LoadSendPostsTo($SendPostsToFile) {
	//carica la lista dei destinatari:
	$DestArray = array ();
	$fp = fopen($SendPostsToFile, "r");
	while (!feof($fp)) {
		list (,, $contact, $contactID,) = explode(':', fgets($fp, 1024));
		if ($contact && $contactID)
			$SendPostsTo .= "$contact:$contactID;";
	}
	fclose($fp);
	return $SendPostsTo;
}

function UpdatePosts($pagename, & $page, & $new) {
	global $IsPagePosted, $SendPostsFile, $SendPostsTimeFmt, $Now, $Newline, $SendPostsItemFmt, $PostTime;

	if (!$IsPagePosted)
		return;
	$fp = @ fopen($SendPostsFile, "a");
	if ($fp) {
		$PostTime = strftime($SendPostsTimeFmt, $Now);
		fputs($fp, str_replace("\n", $Newline, FmtPageName("$Now $SendPostsItemFmt", $pagename))."\n");
		fclose($fp);
	}
}

function SendPosts($to, $subject, $msg, $headers) {
	$toarray = array ();
	$ContactArray = array ();

	$toarray = explode(";", $to);

	foreach ($toarray as $line) {
		list ($contact, $contactID) = explode(':', $line);
		$ContactArray[trim($contact)][] = trim($contactID);
	}

	$ContactArrayKeys = array_keys($ContactArray);
	foreach ($ContactArrayKeys as $Contact) {
		switch ($Contact) {
			case "jabber" :
				JabberPost($ContactArray[$Contact], $subject, $msg, $headers);
				break;
			case "msn" :
				MsnPost($ContactArray[$Contact], $subject, $msg, $headers);
				break;
			case "email" :
				EmailPost($ContactArray[$Contact], $subject, $msg, $headers);
				break;
			default :
				break;
		}
	}
}

function JabberPost($to, $subject, $msg, $headers) {
	global $JabberPostUsername, $JabberPostPassword, $JabberPostServer, $JabberPostPort, $JabberPostResource;

	require_once ("presence/jabberposts/class.jabberposts.php");
	$jid = new ClassJabberPosts($JabberPostServer, $JabberPostPort, $JabberPostUsername, $JabberPostPassword, $JabberPostResource);
	$jid->Connect();
	$jid->SendAuth();

	foreach ($to as $contact) {

		$jid->SendMessage($contact, "normal", NULL, array (// body, thread... whatever
		"body" => $msg), $payload);
	}
	$jid->Disconnect();
}
function MsnPost($to, $subject, $msg, $headers) {
}
function EmailPost($to, $subject, $msg, $headers) {
}
//----------------------------------------------------------------------------------------
?>
